library(frm)
library(frmpd)


##### Data and Variables

dados <- read.table(file="D:/data.txt",header=T,sep="\t")

attach(dados)
id <- id
time <- time
y <- LEVERAGE
X <- cbind(GROWTH,SIZE,PROFITABILITY,TANGIBILITY)
timed <- cbind(time.2008,time.2009,time.2010,time.2011)
detach()


##### Table 3

D <- matrix(0,nrow=length(id),ncol=length(unique(id)))
a <- 0
for(j in unique(id))
{
	a <- a+1
	D[id==j,a] <- 1
}
dimnames(D) <- list(NULL,paste("D",1:length(unique(id)),sep="."))

### Logit
frm(y,cbind(X,timed,D),linkfrac="logit",var.type="cluster",var.cluster=id,intercept=F)

### Probit (QMLpfe)
frm(y,cbind(X,timed,D),linkfrac="probit",var.type="cluster",var.cluster=id,intercept=F)

### Probit (QMLcre)
frmpd(id,time,y,X,type="QMLcre",var.type="cluster",link="probit",tdummies=T)

### Cloglog
frm(y,cbind(X,timed,D),linkfrac="cloglog",var.type="cluster",var.cluster=id,intercept=F)

### Loglog
frm(y,cbind(X,timed,D),linkfrac="loglog",var.type="cluster",var.cluster=id,intercept=F)


##### Table 4

### Logit
frmpd(id,time,y,X,type="GMMww",var.type="cluster",link="logit",tdummies=T,bootstrap=T,control=list(eval.max=4000,iter.max=2000))
frmpd(id,time,y,X,type="GMMc",var.type="cluster",link="logit",tdummies=T,bootstrap=T,control=list(eval.max=4000,iter.max=2000))
frmpd(id,time,y,X,type="GMMbgw",var.type="cluster",link="logit",tdummies=T,bootstrap=T,control=list(eval.max=4000,iter.max=2000))

### Cloglog
frmpd(id,time,y,X,type="GMMww",var.type="cluster",link="cloglog",tdummies=T,bootstrap=T,control=list(eval.max=4000,iter.max=2000))
frmpd(id,time,y,X,type="GMMc",var.type="cluster",link="cloglog",tdummies=T,bootstrap=T,control=list(eval.max=4000,iter.max=2000))
frmpd(id,time,y,X,type="GMMbgw",var.type="cluster",link="cloglog",tdummies=T,bootstrap=T,control=list(eval.max=4000,iter.max=2000))

rm(list=ls())


